﻿![Vanara](https://raw.githubusercontent.com/dahall/Vanara/master/docs/icons/VanaraHeading.png)
### **Vanara.PInvoke.Shell32 NuGet Package**
[![Version](https://img.shields.io/nuget/v/Vanara.PInvoke.Shell32?label=NuGet&style=flat-square)](https://github.com/dahall/Vanara/releases)
[![Build status](https://img.shields.io/appveyor/build/dahall/vanara?label=AppVeyor%20build&style=flat-square)](https://ci.appveyor.com/project/dahall/vanara)

PInvoke API (methods, structures and constants) imported from Windows Shell32.dll.

### **What is Vanara?**

[Vanara](https://github.com/dahall/Vanara) is a community project that contains various .NET assemblies which have P/Invoke functions, interfaces, enums and structures from Windows libraries. Each assembly is associated with one or a few tightly related libraries.

### **Issues?**

First check if it's already fixed by trying the [AppVeyor build](https://ci.appveyor.com/nuget/vanara-prerelease).
If you're still running into problems, file an [issue](https://github.com/dahall/Vanara/issues).

### **Included in Vanara.PInvoke.Shell32**

Functions | Enumerations | Structures | Interfaces
--- | --- | --- | ---
AssocCreateForClasses AssocGetDetailsOfPropKey CDefFolderMenu_Create2 CommandLineToArgvW DragAcceptFiles DragFinish DragQueryFile DragQueryPoint DuplicateIcon ExtractAssociatedIcon ExtractAssociatedIconEx ExtractIcon ExtractIconEx FindExecutable GetCurrentProcessExplicitAppUserModelID GetFileNameFromBrowse ILAppendID ILClone ILCloneFirst ILCombine ILCreateFromPath ILFindChild ILFindLastID ILFree ILGetNext ILGetSize ILIsEqual ILIsParent ILLoadFromStreamEx ILRemoveLastID ILSaveToStream InetIsOffline InitNetworkAddressControl InitVariantFromStrRet IsNetDrive IsUserAnAdmin MIMEAssociationDialog OpenRegStream PathCleanupSpec PathGetShortPath PathIsExe PathIsSlow PathMakeUniqueName PathResolve PathYetAnotherMakeUniqueName PickIconDlg PifMgr_CloseProperties PifMgr_GetProperties PifMgr_OpenProperties PifMgr_SetProperties ReadCabinetState RealDriveType RestartDialog RestartDialogEx SetCurrentProcessExplicitAppUserModelID SHAddDefaultPropertiesByExt SHAddFromPropSheetExtArray SHAddToRecentDocs SHAlloc SHAppBarMessage SHAssocEnumHandlers SHAssocEnumHandlersForProtocolByApplication SHBindToFolderIDListParent SHBindToFolderIDListParentEx SHBindToObject SHBindToParent SHBrowseForFolder SHChangeNotification_Lock SHChangeNotification_Unlock SHChangeNotify SHChangeNotifyDeregister SHChangeNotifyRegister SHChangeNotifyRegisterThread SHCreateAssociationRegistration SHCreateDataObject SHCreateDefaultContextMenu SHCreateDefaultExtractIcon SHCreateDefaultPropertiesOp SHCreateDirectory SHCreateDirectoryEx SHCreateFileExtractIconW SHCreateItemFromIDList SHCreateItemFromParsingName SHCreateItemFromRelativeName SHCreateItemInKnownFolder SHCreateItemWithParent SHCreatePropSheetExtArray SHCreateShellFolderView SHCreateShellFolderViewEx SHCreateShellItem SHCreateShellItemArray SHCreateShellItemArrayFromDataObject SHCreateShellItemArrayFromIDLists SHCreateShellItemArrayFromShellItem SHCreateStdEnumFmtEtc SHDefExtractIcon SHDestroyPropSheetExtArray SHDoDragDrop Shell_GetCachedImageIndex Shell_GetImageLists Shell_MergeMenus Shell_NotifyIcon Shell_NotifyIconGetRect ShellAbout ShellExecute ShellExecuteEx SHEmptyRecycleBin SHEnumerateUnreadMailAccountsA SHEnumerateUnreadMailAccountsW SHEvaluateSystemCommandTemplate SHFileOperation SHFind_InitMenuPopup SHFindFiles SHFlushSFCache SHFormatDrive SHFree SHFreeNameMappings SHGetAttributesFromDataObject SHGetDataFromIDList SHGetDesktopFolder SHGetDiskFreeSpaceA SHGetDiskFreeSpaceEx SHGetDiskFreeSpaceW SHGetDriveMedia SHGetFileInfo SHGetFolderLocation SHGetFolderPath SHGetFolderPathAndSubDir SHGetFolderPathEx SHGetIconOverlayIndex SHGetIDListFromObject SHGetImageList SHGetInstanceExplorer SHGetItemFromDataObject SHGetItemFromObject SHGetKnownFolderIDList SHGetKnownFolderItem SHGetKnownFolderPath SHGetLocalizedName SHGetNameFromIDList SHGetNewLinkInfo SHGetPathFromIDList SHGetPathFromIDListEx SHGetPropertyStoreForWindow SHGetPropertyStoreFromIDList SHGetPropertyStoreFromParsingName SHGetRealIDL SHGetSetFolderCustomSettings SHGetSetSettings SHGetSettings SHGetStockIconInfo SHGetTemporaryPropertyForItem SHGetUnreadMailCountW SHHandleUpdateImage SHInvokePrinterCommand SHIsFileAvailableOffline SHLimitInputEdit SHLoadInProc SHLoadNonloadedIconOverlayIdentifiers SHMapPIDLToSystemImageListIndex SHMultiFileProperties SHObjectProperties SHOpenFolderAndSelectItems SHOpenWithDialog SHParseDisplayName SHPathPrepareForWrite SHPropStgCreate SHPropStgReadMultiple SHPropStgWriteMultiple SHQueryRecycleBin SHQueryUserNotificationState SHRemoveLocalizedName SHReplaceFromPropSheetExtArray SHResolveLibrary SHRestricted SHSetDefaultProperties SHSetInstanceExplorer SHSetKnownFolderPath SHSetLocalizedName SHSetTemporaryPropertyForItem SHSetUnreadMailCountW SHShellFolderView_Message SHShowManageLibraryUI SHSimpleIDListFromPath SHTestTokenMembership SHUpdateImage SHUpdateRecycleBinIcon SHValidateUNC SignalFileOpen StgMakeUniqueName TranslateURLW URLAssociationDialogW VariantToStrRet Win32DeleteFile WriteCabinetState                                                                     | DROPIMAGETYPE FD_FLAGS ShellWindowFindWindowOptions ShellWindowTypeConstants TI_FLAGS APPACTIONFLAGS APPINFODATAFLAGS PUBAPPINFOFLAGS ABE ABM ABN ABS ASSOCCLASS NIF NIIF NIM NIN NIS OFFLINE_STATUS PRINTACTION QUERY_USER_NOTIFICATION_STATE ShellExecuteMaskFlags ShellFileOperation SHERB SHGFI SHGNLI SHGSI SHSTOCKICONID AUTOCOMPLETEOPTIONS OfflineFolderStatus ShellFolderViewOptions ShellSpecialFolderConstants BHID FOLDERTYPEID BrowseForFolderMessages BrowseInfoFlag CLOSEPROPS CSIDL FCS FOLDERCUSTOMSETTINGSMASK GPFIDL_FLAGS MM OFASI OPEN_AS_INFO_FLAGS OPENPROPS PCS PRF QITIP RESTRICTIONS SCNRT_STATUS SHARD SHCNE SHCNF SHCNRF SHDID SHFMT_ID SHFMT_OPT SHGetDataFormat SHGFP SHIL SHOP SHPPFW SSF VALIDATEUNC GetIconLocationFlags GetIconLocationResultFlags PDTIMER PROGDLG ControlPanelItem CPVIEW APPDOCLISTTYPE ARCONTENT ASSOC_FILTER ASSOCIATIONLEVEL ASSOCIATIONTYPE DATAOBJ_GET_ITEM_FLAGS FILE_USAGE_TYPE KNOWNDESTCATEGORY OF_CAP PLACEHOLDER_STATES SLGP SVGIO SYNC_TRANSFER_STATUS UNDOCK_REASON SPBEGINF SPINITF SPTEXT ACTIVATEOPTIONS ADJACENT_DISPLAY_EDGES APPLICATION_VIEW_MIN_WIDTH APPLICATION_VIEW_ORIENTATION APPLICATION_VIEW_STATE EDGE_GESTURE_KIND NATIVE_DISPLAY_ORIENTATION MONITOR_APP_VISIBILITY ATTACHMENT_ACTION ATTACHMENT_PROMPT CDBE_ACTIONS CDB2GVF CDB2N CDBOSC CMF CMIC GCS DEFAULT_FOLDER_MENU_RESTRICTIONS DBIF DBIM DBIMF DESKTOP_SLIDESHOW_DIRECTION DESKTOP_SLIDESHOW_OPTIONS DESKTOP_SLIDESHOW_STATE DESKTOP_WALLPAPER_POSITION DSH_FLAGS AHE_TYPE EC_HOST_UI_MODE EXPLORER_BROWSER_FILL_FLAGS EXPLORER_BROWSER_OPTIONS EXPCMDFLAGS EXPCMDSTATE EXPLORERPANESTATE IEIFLAG CDCONTROLSTATEF FDAP FDE_SHAREVIOLATION_RESPONSE FILEOPENDIALOGOPTIONS MERGE_UPDATE_STATUS TRANSFER_SOURCE_FLAGS FILEOP_FLAGS CM_ENUM_FLAGS CM_MASK CM_SET_WIDTH_VALUE CM_STATE FOLDERLOGICALVIEWMODE FVTEXTTYPE SORTDIRECTION FFFP_MODE KF_CATEGORY KF_DEFINITION_FLAGS KF_REDIRECT_FLAGS KF_REDIRECTION_CAPABILITIES KNOWN_FOLDER_FLAG KNOWNFOLDERID APPLICATION_VIEW_SIZE_PREFERENCE NSTCECLICKTYPE NSTCEHITTEST NSTCFOLDERCAPABILITIES NSTCGNI NSTCITEMSTATE NSTCROOTSTYLE NSTCSTYLE NSTCSTYLE2 NAMESPACEWALKFLAG NMCII_FLAGS NMCSAEI_FLAGS NWMF OPPROGDLGF PDMODE PDOPSTATUS SPACTION PACKAGE_EXECUTION_STATE DEF_SHARE_ID SHARE_ROLE CATEGORYINFO_FLAGS CATSORT_FLAGS FOLDER_ENUM_MODE SHCIDS SHCONTF SHGDNF ISIOI SFGAO SIATTRIBFLAGS SICHINTF SIGDN SIIGBF DEFAULTSAVEFOLDERTYPE LIBRARYFOLDERFILTER LIBRARYMANAGEDIALOGOPTIONS LIBRARYOPTIONFLAGS LIBRARYSAVEFLAGS SHELL_LINK_DATA_FLAGS ShellDataBlockSignature SLR_FLAGS SMC SMDM SMINFOFLAGS SMINFOMASK SMINFOTYPE SMINIT SMINV SMSET EXPPS IRTIR_TASK ITSSFLAG BROWSERFRAMEOPTIONS FCT FCW FOLDERFLAGS FOLDERVIEWMODE FOLDERVIEWOPTIONS SBSP SFVM SV2GV SV3CVW3_FLAGS SVSIF SVUIA STPFLAG TBPFLAG THUMBBUTTONFLAGS THUMBBUTTONMASK TRANSFER_ADVISE_STATE VPCOLORFLAGS VPWATERMARKFLAGS SHCOLSTATE STRRET_TYPE WTS_ALPHATYPE IURL_INVOKECOMMAND_FLAGS IURL_SETURL_FLAGS TRANSLATEURL_IN_FLAGS URLASSOCIATIONDIALOG_IN_FLAGS                                             | CIDA DROPDESCRIPTION DROPFILES FILE_ATTRIBUTES_ARRAY FILEDESCRIPTOR FILEGROUPDESCRIPTOR NETRESOURCE NRESARRAY SHDRAGIMAGE NOTIFICATION_USER_INPUT_DATA APPCATEGORYINFO APPCATEGORYINFOLIST APPINFODATA PUBAPPINFO SLOWAPPINFO APPBARDATA ASSOCIATIONELEMENT NOTIFYICONDATA NOTIFYICONIDENTIFIER SHELLEXECUTEINFO SHFILEINFO SHFILEOPSTRUCT SHQUERYRBINFO SHSTOCKICONINFO BROWSEINFO CABINETSTATE COORD CSFV DATABLOCKHEADER DEFCONTEXTMENU EXP_DARWIN_LINK EXP_SPECIAL_FOLDER EXP_SZ_LINK HLOCK HPIF HPSXA NT_CONSOLE_PROPS NT_FE_CONSOLE_PROPS OPENASINFO PROPPRG SFV_CREATE SHARDAPPIDINFO SHARDAPPIDINFOIDLIST SHARDAPPIDINFOLINK SHChangeNotifyEntry SHDESCRIPTIONID SHELLFLAGSTATE SHELLSTATE SHFOLDERCUSTOMSETTINGS CMINVOKECOMMANDINFOEX DESKBANDINFO COMDLG_FILTERSPEC CM_COLUMNINFO SORTCOLUMN KNOWNFOLDER_DEFINITION NSTCCUSTOMDRAW PERSIST_FOLDER_TARGET_INFO PREVIEWHANDLERFRAMEINFO CATEGORY_INFO EXTRASEARCH SHELL_ITEM_RESOURCE SMDATA FOLDERSETTINGS PFOLDERSETTINGS SV2CVW2_PARAMS THUMBBUTTON ITEMIDLIST SHELLDETAILS SHITEMID STRRET URLINVOKECOMMANDINFO                                                                                                                                                                                                 | IDestinationStreamFactory IShellWindows ITranscodeImage IInputPanelConfiguration IInputPanelInvocationConfiguration INotificationActivationCallback IObjectArray IObjectCollection IAppPublisher IEnumPublishedApps IPublishedApp IPublishedApp2 IShellApp DFConstraint DShellFolderViewEvents Folder Folder2 Folder3 FolderItem FolderItem2 FolderItems FolderItems2 FolderItems3 FolderItemVerb FolderItemVerbs IAutoComplete IAutoComplete2 IFileSearchBand IFolderViewOC INewWDEvents IShellDispatch IShellDispatch2 IShellDispatch3 IShellDispatch4 IShellDispatch5 IShellDispatch6 IShellFolderViewDual IShellFolderViewDual2 IShellFolderViewDual3 IShellLinkDual IShellLinkDual2 IWebWizardHost IWebWizardHost2 IExtractIconA IExtractIconW IProgressDialog IOpenControlPanel IApplicationAssociationRegistration IApplicationDestinations IApplicationDocumentLists IDefaultExtractIconInit IEnumIDList IEnumFullIDList IFileIsInUse IFileSystemBindData IFileSystemBindData2 IPersistIDList IQueryInfo IAccessibilityDockingService IAccessibilityDockingServiceCallback IAccessibleObject IActionProgress IActionProgressDialog IAppActivationUIInfo IApplicationActivationManager IApplicationDesignModeSettings IApplicationDesignModeSettings2 IAppVisibility IAppVisibilityEvents IAssocHandler IAssocHandlerInvoker IEnumAssocHandlers IAttachmentExecute IAutoCompleteDropDown ICDBurn ICDBurnExt ICommDlgBrowser ICommDlgBrowser3 IFolderFilter IFolderFilterSite IContextMenu IContextMenu2 IContextMenu3 IContextMenuCB ICopyHookA ICopyHookW ICreateProcessInputs ICreatingProcess IDataObjectProvider IDataTransferManagerInterop IDefaultFolderMenuInitialize IDelegateFolder IDeskBand IDeskBand2 IDesktopWallpaper IDockingWindow IDragSourceHelper IDragSourceHelper2 IDropTargetHelper IEnumerableView IEnumReadyCallback IEnumObjects IExecuteCommand IExecuteCommandHost IExecuteCommandApplicationHostEnvironment IInitializeCommand IExplorerBrowser IExplorerBrowserEvents IEnumExplorerCommand IExplorerCommand IExplorerCommandProvider IExplorerCommandState IExplorerPaneVisibility IExtractImage IExtractImage2 IFileDialog IFileDialog2 IFileDialogControlEvents IFileDialogCustomize IFileDialogEvents IFileOpenDialog IFileOperationProgressSink IFileSaveDialog IFileSyncMergeHandler IModalWindow IFileOperation IColumnManager IFolderView IFolderView2 IFolderViewHost IFolderViewSettings IResultsFolder IFrameworkInputPane IFrameworkInputPaneHandler IHandlerActivationHost IHandlerInfo IHandlerInfo2 IDynamicHWHandler IHWEventHandler IHWEventHandler2 IQueryCancelAutoPlay IQueryContinue IUserNotification2 IUserNotificationCallback IImageRecompress IInitializeWithBindCtx IInitializeWithFile IInitializeWithItem IInitializeWithPropertyStore IInitializeWithStream IInitializeWithWindow IInputObject IInputObject2 IInputObjectSite IInsertItem IItemNameLimits IKnownFolder IKnownFolderManager ILaunchSourceAppUserModelId ILaunchSourceViewSizePreference ILaunchTargetViewSizePreference ILaunchTargetMonitor INameSpaceTreeAccessible INameSpaceTreeControl INameSpaceTreeControl2 INameSpaceTreeControlDropHandler INameSpaceTreeControlEvents INameSpaceTreeControlFolderCapabilities INamespaceWalk INamespaceWalkCB INamespaceWalkCB2 INewMenuClient INewWindowManager IObjectProvider IObjectWithAppUserModelId IObjectWithBackReferences IObjectWithCancelEvent IObjectWithProgId IObjectWithSelection IIOCancelInformation IOperationsProgressDialog IPackageDebugSettings IPackageDebugSettings2 IPackageExecutionStateChangeNotification IParentAndItem IPersistFolder IPersistFolder2 IPersistFolder3 IPreviewHandler IPreviewHandlerFrame IPreviewHandlerVisuals IPreviousVersionsInfo ICurrentItem IDelegateItem IDisplayItem IIdentityName IPreviewItem IRelatedItem ITransferMediumItem IViewStateIdentityItem IRemoteComputer ISearchBoxInfo IProfferService IServiceProvider ISharingConfigurationManager IShellExtInit ICategorizer ICategoryProvider IEnumExtraSearch IObjectWithFolderEnumMode IShellFolder IShellFolder2 IShellIcon IShellIconOverlayIdentifier IEnumShellItems IParseAndCreateItem IShellItem IShellItem2 IShellItemArray IShellItemImageFactory IShellItemFilter IEnumResources IShellItemResources IShellLibrary IResolveShellLink IShellLinkDataList IShellLinkW IShellMenu IShellMenuCallback IShellPropSheetExt IRunnableTask IShellTaskScheduler IBrowserFrameOptions IFolderViewOptions IShellBrowser IShellFolderViewCB IShellView IShellView2 IShellView3 IStartMenuPinnedList IStorageProviderBanners IStorageProviderCopyHook IStreamAsync IStreamUnbufferedInfo ICustomDestinationList ITaskbarList ITaskbarList2 ITaskbarList3 ITaskbarList4 IThumbnailHandlerFactory ITransferAdviseSink ITransferDestination ITransferSource IUpdateIDList IUserAccountChangeCallback IUserNotification IVirtualDesktopManager IVisualProperties IStorageProviderPropertyHandler IStorageProviderHandler IThumbnailProvider IUniformResourceLocator 
